//
//  PatchClient.h
//  VoiceToolOSX
//
//  Created by Taihei Monma on Tue Sep 02 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "senariopatch_mixer.h"
#import "senariopatch.h"
#import "ControllerProtocol.h"

@interface PatchClient : NSObject {
	NSString *origPath;
	NSString *newPath;
	NSString *patchFile;
	int game;
	BOOL isMixer;
	id <ControllerProtocol> controller;
}
- (id)initWithSeenDir:(NSString *)dir patchFile:(NSString *)patchFile 
		game:(int)n isMixer:(BOOL)m parent:(id <ControllerProtocol>)aParent;
- (void)dealloc;
- (int)doPatch;
- (void)patch;

@end
