//
// senariopatch.cpp
//@ViIt@C
//
// Fsenariopatch ViIt@C ViIt@C ςŁ[
//
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "senariopatch.h"

#define TRUE 1
#define FALSE 0
#define swap_endian32(x) x>>24 | (x&0xff0000)>>8 | (x&0xff00)<<8 | x<<24
#define swap_endian16(x) x>>8 | x<<8

#ifdef DEBUG
//AhXG[`FbNp

// Xgɒǉ
void Csenariopatch::addjump(JumpPtr* ptr,int a,int b,int address){
	if (*ptr==NULL) {
		// XgI[ ɒǉ
		*ptr=new sjumpdata;
		(*ptr)->address=address;
		(*ptr)->a=a;
		(*ptr)->b=b;
		(*ptr)->next=NULL;
	}else{
		addjump(&((*ptr)->next),a,b,address);
	}
}
void Csenariopatch::chkjump(JumpPtr ptr,char* a,char* b){
	if (ptr==NULL) return;
	if (*(a+ptr->a)!=*(b+ptr->b)){
		if (!((*(a+ptr->a)==(char)0xFF)&&(*(b+ptr->b)=(char)0x0e))){
			printf("%x WvG[ F%x(at %x(%x)) F%x(at %x(%x))\n",
			ptr->address,*(a+ptr->a),ptr->a+currentpadlen,ptr->a,*(b+ptr->b),ptr->b+currentpadlen,ptr->b);
		}
	}
	chkjump(ptr->next,a,b);
}
// listdelete
void Csenariopatch::deletejump(JumpPtr ptr){
	if (ptr==NULL) return;
	deletejump (ptr->next);
	delete ptr;
}
#endif

int Csenariopatch::getint(unsigned char* data){
	return (((int)(*(data+3))*256 + (int)(*(data+2)) )*256 + (int)(*(data+1)))*256 + (int)(*data);
}

// Xgɒǉ
void Csenariopatch::addlist(PatchPtr* ptr,char* vfn,int address){
	if (*ptr==NULL) {
		// XgI[ ɒǉ
		*ptr=new spatch;
		(*ptr)->address=address;
		(*ptr)->voicefilename=new char[strlen(vfn)+1];
		strcpy((*ptr)->voicefilename,vfn);
		(*ptr)->used=FALSE;
		(*ptr)->next=NULL;
	}else{
		addlist(&((*ptr)->next),vfn,address);
	}
}

// pb`KpőTCYԂ
int Csenariopatch::calclen(PatchPtr ptr){
	if (ptr!=NULL) {
		// pb` 0E 30 t@C 00 / 0E 36
		return calclen(ptr->next)+strlen(ptr->voicefilename)+5;
	}else{
		return 0;
	}
}

int Csenariopatch::calcoffset(PatchPtr ptr,int address){
	if (ptr!=NULL) {
		// pb` 0E 30 t@C 00 / 0E 36
		if(ptr->address<address+padlen){
			return calcoffset(ptr->next,address)+strlen(ptr->voicefilename)+5;
		}else{
			return calcoffset(ptr->next,address);
		}
	}else{
		return 0;
	}	
}

// Ώaddress̃pb`ΕԂ
PatchPtr Csenariopatch::getpatch(PatchPtr ptr,int address){
	if (ptr==NULL) return NULL;
	if (ptr->address==address){
		ptr->used=TRUE;
		return ptr;
	}
	return getpatch(ptr->next,address);
}

#ifdef CHKLIST
// gppatch(܂ԈႢ `FbN
void Csenariopatch::chklist(PatchPtr ptr){
	if (ptr!=NULL){
		if (ptr->used==FALSE){
			printf("\nError: unused patch %s,%d\n",ptr->voicefilename,ptr->address);
			fcloseall();
			exit(1);
		}
		chklist(ptr->next);
	}
}
#endif

// listdelete
void Csenariopatch::deletelist(PatchPtr ptr){
	if (ptr==NULL) return;
	delete [] ptr->voicefilename;
	deletelist (ptr->next);
	delete ptr;
}
	;

int Csenariopatch::senariopatch(const char* infile,const char* outfile,const char* patchfile, int ver,id <ControllerProtocol>controller){
	version=ver;

	char buffer[16];
	unsigned int tmp;
	
	/*
	FILE* output;
	output=fopen(infile,"rb");
	fprintf(output,"%s,%d\n%s,%d\n%s,%d\n",infile,strlen(infile),outfile,strlen(outfile),patchfile,strlen(patchfile));
	fclose(output);
	*/
	
	FILE* in;
	in=fopen(infile,"rb");
	if (in==NULL) {
		
		printf("not found:%s\n",infile);
		
		return -1;
	}

	fread(buffer,sizeof(char),16,in); // PACL Ƃwb_
	if (strncmp(buffer,"PACL",4)!=0 ){
		
		printf("not visualarts archive:%s\n",infile);
		return -1;
	}

	FILE* out;
	out=fopen(outfile,"wb");
	if (out==NULL){
		
		printf("can't open:%s\n",outfile);
		return -1;
	}
	fwrite(buffer,sizeof(char),16,out);
	
	int filenum;
	fread(&tmp,sizeof(int),1,in);
	filenum = swap_endian32(tmp);
	fwrite(&tmp,sizeof(int),1,out);


	FileInfoPtr header=new sfileinfo[filenum];

	fread(buffer,sizeof(char),12,in);   // Ԃ
	fwrite(buffer,sizeof(char),12,out); 

	int nazo,i;

	//wb_
	for (i=0;i<filenum;i++){
		fread(header[i].filename,sizeof(char),16,in);
		fwrite(header[i].filename,sizeof(char),16,out);
		header[i].outheaderptr=ftell(out); // ̒iKł͉O̒l킩Ȃ̂
		                                   // Ƃŏ߂Ƀwb_l̈ʒuT
		fread(&tmp,sizeof(int),1,in);
		header[i].from = swap_endian32(tmp);
		fwrite(&tmp,sizeof(int),1,out);
			// (SEEN???.TXT̊JnAhXBwb_="PACK 00 00 00 00"+ arcsize + filesize)
		fread(&tmp,sizeof(int),1,in);
		header[i].arcsize = swap_endian32(tmp);
		fwrite(&tmp,sizeof(int),1,out);	// 
		fread(&tmp,sizeof(int),1,in);
		header[i].filesize = swap_endian32(tmp);
		fwrite(&tmp,sizeof(int),1,out);	// 
		fread(&nazo,sizeof(int),1,in);		// ͂悭킩Ȃ
		fwrite(&nazo,sizeof(int),1,out);	// ̂܂܃Rs[ł
	}

	PatchPtr* patchlist=new PatchPtr[filenum];
	for(i=0;i<filenum;i++){
		patchlist[i]=NULL;
	}

	FILE* patch;
	patch=fopen(patchfile,"rb");
	if (patch==NULL){
		
		printf("not found:%s\n",patchfile);
		return -1;
	}
	char voicefilename[20];    //ĂƁ[B悤Ȃ̂͒m
	char senariofilename[12];  // SEEN???.TXT
	int address;
	while(!feof(patch)){
		int ret=fscanf(patch,"%s %s %d",voicefilename,senariofilename,&address);
		//printf("%s %s %d",voicefilename,senariofilename,address);
		if (ret!=0 && ret!=EOF){
			for(i=0;i<filenum;i++){
				if(strcmp(senariofilename,header[i].filename)==0){
					addlist(&patchlist[i],voicefilename,address);
				}
			}
		}
	}
	fclose(patch);
	[controller setProgressMaxValue1: (double)filenum];
	//f[^{
	for (i=0;i<filenum;i++){

		fseek(in,header[i].from,SEEK_SET); // ̓t@CJnʒu
		
		/*
#ifdef DEBUG
fprintf(stdout,"%d %s\n",i,header[i].filename);
#endif
*/
		filenumber=i;

		// upӂēǂ
		char* compressedbuf=new char[header[i].arcsize];
		fread(compressedbuf,header[i].arcsize,sizeof(char),in);

		// WJpӂēWJ
		char* plainbuf=new char[header[i].filesize];
		extract(compressedbuf,header[i].arcsize,plainbuf,header[i].filesize);

		delete [] compressedbuf; // vȂ

/*
#ifdef OUT_SEEN
	FILE* test;
	test=fopen(header[i].filename,"wb");
	if (test==NULL){
printf("can't open",header[i].filename);
		return -1;
	}
	fwrite(plainbuf,sizeof(char),header[i].filesize,test);
	printf("writing plainbuf in %s\n",header[i].filename);
	fclose(test);
#endif
*/
		// pb`
		int patchsize=calclen(patchlist[i]); // pb`KpőTCY
		int patchedsize=header[i].filesize+patchsize;
		char* patchedbuf=new char[patchedsize]; // KpTCY̒u

/*
#ifdef DEBUG
currentjump=NULL;
#endif
*/
		currentpatch=patchlist[i];
		senariotrace((unsigned char*)plainbuf,(unsigned char*)patchedbuf,header[i].filesize);

/*
#ifdef CHKLIST
chklist(patchlist[i]); // gpȂ`FbN
#endif
*/
		deletelist(patchlist[i]); // iԖڂ̃t@Cppb`BvȂ

/*
#ifdef DEBUG
chkjump(currentjump,plainbuf+currentpadlen,patchedbuf+currentpadlen);
deletejump(currentjump);
#endif
*/
		delete [] plainbuf; // vȂ
		
		// 
		int start=ftell(out);
		int size = patchedsize;
		int arcsize = (size+7)/8*9+16; // wb_16A{̂8Â؂1̃tOt
		fwrite("PACK\0\0\0\0",sizeof(char),8,out);
		tmp = swap_endian32(size);
		fwrite(&tmp,sizeof(int),1,out);			// wb_
		tmp = swap_endian32(arcsize);
		fwrite(&tmp,sizeof(int),1,out);

		// XChkB
		// Ƃ肠悤ɂȂ炿ƈkR[hɂ悤
		char ff=(char)0xff;
		for (int writect=0; writect<size;) {
			fwrite(&ff,sizeof(char),1,out);
			for (int j=0; j<8 && writect<size; j++, writect++) {
				fwrite(&patchedbuf[writect],sizeof(char),1,out);
			}
		}

		delete [] patchedbuf; // vȂ

		// wb_̒l
		long bup=ftell(out);
		fseek(out,header[i].outheaderptr,SEEK_SET);
		tmp = swap_endian32(start);
		fwrite(&tmp,sizeof(int),1,out);	// 擪ʒu
		tmp = swap_endian32(arcsize);
		fwrite(&tmp,sizeof(int),1,out);	// ɓTCY
		tmp = swap_endian32(size);
		fwrite(&tmp,sizeof(int),1,out);	// t@CTCY
		fseek(out,bup,SEEK_SET);
		[controller addProgress1];
	}

	delete [] patchlist; // vȂ



	fclose(in);
	fclose(out);

	return 0;
}

void Csenariopatch::extract(char* src,int arcsize,char* dest,int filesize){
	char* dataend=src+arcsize;
	char* outend=dest+filesize;
	char flag;
	int flagcount=0;

	src+=16; // wb_΂

	while(src<dataend && dest<outend){
		if (flagcount==0){
			flagcount=8;    // tO؂ꂽ⋋
			flag=*src++;
		}

		if (flag & 0x80) {	// tO1Ȃ
			*dest++ = *src++;	// oCĝ܂
		}else{              // łȂ
			// QoCgǂ ab cd 0xcda+1oCgO0xb+2oCgRs[
			unsigned char tmp[2];
			tmp[0]=*src++; tmp[1]=*src++;
			int offset= (int)(tmp[1])*16 + (int)(tmp[0] & 0xf0)/16 + 1;
			int size=(int)(tmp[0] & 0x0f)+2;

			char* cpyptr=dest-offset;
			for(int i=0;i<size;i++) *dest++=*cpyptr++;
		}

		flagcount--;
		flag<<=1;
	}
	return;
}

// senariotrace.cpp

// Ȃ肨[parceiƂقǂłȂ Ȃ
// JUMP̔ѐ␳ƔR}hǉ
// ߂ǂ̌`ĂƂłɍR[h()

// A啔
// xkanonsenario.cc,senario_graphics.cc,senario_flags.cc
// 炻̂܂܎ĂĊȁBGPLłȂłEEE
// IȂǂł͂邯ǁBm邩

void Csenariopatch::Int() {
	 int i;
	 for (i=0; i<4; i++){
		*dest++=*data++;
	}
	 return;
	 }

void Csenariopatch::Data() {
    unsigned char c = *dest = *data;
    int len = (int(c)>>4) & 0x07;
    int ret = 0;

    int i; for (i=len-1; i>0; i--) {
		ret <<= 8;
		ret |= (int(dest[i]=data[i])&0xff);
	}
	ret <<= 4; ret |= c&0x0f;
	data += len;
	dest += len;
	return;
}

void Csenariopatch::Condition() {
	// 

	int parenth_count = 0; // '(...)' ̑dx
	// ÍA'(...)' 邱ƁB
	while(1) {
		int c = *dest++=*data++;
		// '(..)' ̏
		if (c == '(') {
			parenth_count++;
		} else if (c == ')') {
			if (parenth_count == 0 || parenth_count == 1) break; // ')' I
			parenth_count--;
//			if (parenth_count == 0) break; // ŏ '()' II
		// ̑̏̏
		// } else if (c == and_char || c == or_char) { //  and , or Zq
		} else if (c >= 0x36 && c <= 0x55) { // ́A
			Data(); Data();
		}
	}
}

void Csenariopatch::String() {
	if (*data == '@') { // ϐ
		*dest++=*data++;
		Data();
	}else{
		strcpy((char*)dest,(char*)data);
		dest+=strlen((char*)data)+1;
		data+=strlen((char*)data)+1;
	}
}

void Csenariopatch::StringWithFormat() {
	while(*data != 0) {
		int c = *data; c&=0xff;
		if (c == 0xff) {
			*dest++=*data++;
			strcpy((char*)dest, (char*)data);
			dest+=strlen((char*)data)+1;
			data+=strlen((char*)data)+1;
		} else if (c == 0xfe) {
			*dest++=*data++;
			strcpy((char*)dest, (char*)data);
			dest += strlen((char*)data)+1;
			data += strlen((char*)data)+1;
		} else if (c == 0xfd) {
			*dest++=*data++;
			Data();
		} else if (c == 0x28) {
			Condition();
		} else if (c == 0x10) {
			*dest++=*data++; c = *dest++=*data++;
			if (c == 3) {
				Data();
			} else if (c == 2) {
				Data(); Data();
			} else if (c == 1) {
				Data();
			}
		} else {
			break;
		}
	}
	*dest++=*data++;
}

void Csenariopatch::GraphicLoadCmd(){
	//Ђ
	unsigned char subcmd=*dest++=*data++;
	int i;
	int images;
	switch(subcmd){
	case 0x05: case 0x03: case 0x01:
		String();
		Data();
		break;
	case 0x06: case 0x04: case 0x02:
		String();
		for (i=0; i<15; i++) Data();
		break;
	case 0x10: case 0x09: case 0x54:
		String();
		Data();
		break;
	case 0x11:
		String();
		break;
	case 0x22: case 0x24:   
		images = *dest++=*data++;
		if (subcmd == 0x22) {
			String(); 
		} else if (subcmd == 0x24) {
			Data();
		}
		Data();
		// d˂摜̓ǂݍ
		for (i=0; i<images; i++) {
			int sort = *dest++=*data++;
			String();
			switch(sort) {
			case 1: break;
			case 2: Data(); break;
			case 3: 
				for (i=0; i<6; i++) Data(); break;
			case 4:
				for (i=0; i<7; i++) Data(); break;
			}
		}
		break;
	case 0x30: break;
	case 0x31: Data(); break;
	case 0x33: Data(); break;
	case 0x50: break;
	case 0x52: Data(); break;
	default: break;
	}
	return;
}

void Csenariopatch::Graphics(unsigned char cmd)
{
	int arg;
	switch(cmd) {
	case 0x63:
		arg = *dest++=*data++;
		if (arg == 0x20) {
			*dest++=*data++;
			Data();
		} else if (arg == 1) {
			Data(); Data();
			Data(); Data();
			Data();
		} else if (arg == 2) {
			Data();
			Data();
			Data();
		} else if (arg == 0x10) {
		}
			break;
	case 0x64: {
		arg = *dest++=*data++;
		if (arg == 2) {
				int i ;for (i=0; i<8; i++) Data();
			} else if (arg == 4) {
				int i ;for (i=0; i<8; i++) Data();
			} else if (arg == 6) {
				int i ;for (i=0; i<11; i++) Data();
			} else if (arg == 7) {
				int i ;for (i=0; i<5; i++) Data();
			} else if (arg == 16) {
				int i ;for (i=0; i<8; i++) Data();
			} else if (arg == 17) {
				int i ;for (i=0; i<5; i++) Data();
			} else if (arg == 18) {
				int i ;for (i=0; i<5; i++) Data();
			} else if (arg == 21) {
				int i ;for (i=0; i<9; i++) Data();
			} else if (arg == 32) {
				int i ;for (i=0; i<5; i++) Data();
			} else if (arg == 48) {
				int i ;for (i=0; i<10; i++) Data();
			} else if (arg == 50) {
				int i ;for (i=0; i<16; i++) Data();
			} else {
			}
		break; }
	case 0x66:
			if (*data == 0x02) {
				*dest++=*data++;
				int i; for (i=0; i<6; i++) Data();
				StringWithFormat();
			}
			break;
			
	case 0x67:
		arg = *dest++=*data++;
		if (0) {
			} else if (arg == 0) {
				int i ;for (i=0; i<6; i++) Data();
			} else if (arg == 1) {
				int i ;for (i=0; i<8; i++) Data();
				if (version >= 2) Data(); // new version
			}else if (arg == 2) {
				int i ;for (i=0; i<9; i++) Data();
			}else if (arg == 3) {
				int i ;for (i=0; i<11; i++) Data();
			} else if (arg == 5) {
				int i ;for (i=0; i<8; i++) Data();
			} else if (arg == 8) {
				int i ;for (i=0; i<8; i++) Data();
				if (version > 0)  Data();
			} else if (arg == 0x11) {
				Data(); Data();
				if (version >= 2)  Data(); // new version
			} else if (arg == 0x12) {
				Data(); Data(); Data();
			} else if (arg == 0x13) {
				int i ;for (i=0; i<5; i++) Data();
			} else if (arg == 0x15) {
				Data(); Data();
			} else if (arg == 0x18) {
				Data(); Data();
				if (version > 0) Data();
			} else if (arg == 0x20) {
				int i;for (i=0; i<15; i++) Data();
			} else if (arg == 0x21) {
				int i;for (i=0; i<16; i++) Data();
			} else if (arg == 0x22) {
				int i;for (i=0; i<18; i++) Data();
			} else {
			}
			break;
	case 0x68:
		if (*data == 0x10) {
			*dest++=*data++;
			int i;for (i=0; i<5; i++) Data();
			break;
		}
		if (*data != 1) {
			return;
		}
		*dest++=*data++;
		Data(); Data();
		Data(); Data();
		break;
	}
	return;
}

//ϐ
void Csenariopatch::CalcVar(unsigned char cmd) {
	Data();
	if (cmd != 0x56) { // 0x56 : P
		Data();
	}
	if (cmd == 0x57) { // 0x57: R
		Data();
	}
	return;
}
void Csenariopatch::CalcStr() {
	unsigned char c = *dest++ = *data++;
	if (c < 1 || c > 0x40) return;
	Data();
	switch(c) {
		case 1: // 
			String(); break;
		case 2: // strlen
			Data(); break;
		case 3: // strcmp
			Data(); Data(); break;
		case 4: // strcat
			Data(); break;
		case 5: // strcpy
			Data(); break;
		case 6: // itoa
			Data(); Data(); break;
		case 7: // han2zen
			break;
		case 8: // atoi
			Data(); break;
				case 0x10:
		case 0x11:
		case 0x20:
		case 0x21:
		case 0x12:
		case 0x13:
		case 0x22:
		case 0x23:
		case 0x19:
		case 0x29:
			Data(); Data(); break;
		case 0x14:
		case 0x24:
			Data(); Data(); Data(); break;
		case 0x15:
		case 0x16:
		case 0x25:
		case 0x26:
		case 0x17:
		case 0x18:
		case 0x27:
		case 0x28:
			Data(); break;
		case 0x30: break;
	}
	return;
}
void Csenariopatch::Select() {
	unsigned char c = *dest++ = *data++;
	switch(c) {
	case 1: 
	case 2:
	case 3: { // selection
		Data();
		if (*data == 0x22) *dest++ = *data++;
		if (*data == 0) *dest++ = *data++;
		while(*data != 0x23) {
			StringWithFormat();
		}
		*dest++ = *data++;
		break;
		}
	case 4:  // ???
		Data(); break;
	default:
		break;
	}
}

void Csenariopatch::TextWindow(unsigned char cmd) {
	int arg;
	switch(cmd) {
	case 0x01: case 0x03: break;
	case 0x02: *dest++=*data++; break;
	case 0x04: *dest++=*data++; break;
	case 0x05: *dest++=*data++; break;
	case 0x10:
		arg=*dest++=*data++;
		if (arg==2) Data();
		Data(); 
		break;
	case 0xfe: if(version >=3) {
			Int();
		}
		String(); break;
	}
	return;
}

void Csenariopatch::TextWindowEx() { // Ă ////////////////////////////////////////////////////

	PatchPtr patch=getpatch(currentpatch,data-datatop);

	if (patch!=NULL){
		// 0E 30 t@C WAVĐł͗l
		// Ώۂ FF  ̑Oɑ}
		// FF  ̌ɍĐ~(߂ 0E 36)tH

		dest--; // FF͂̊֐ĂԑOŊɏĂ̂

		*dest++=0x0e;
		*dest++=0x30;
		sprintf((char*)dest,patch->voicefilename);
		dest+=strlen(patch->voicefilename);
		*dest++=0x00;

#ifdef CHKLIST
		if (version >=3) {
			fprintf(stdout,"\npatched %s\n%s",patch->voicefilename,data+4);
		}else {
			fprintf(stdout,"\npatched %s\n%s",patch->voicefilename,data);
		}
		fprintf(stdout,"(%s.wav)",patch->voicefilename);
#endif

		*dest++=0xFF; // ɏĂ
	}
	
		if (version >= 3) {
			Int();
		}
		String();

		while (*data==0xff || *data==0x03){
			if(*data==0xff){
				*dest++=*data++; // FF
				if (version >= 3) {
					Int();
				}
				String();
			}else{
				*dest++=*data++; // 03
			}
		}

//I[
	if (patch!=NULL){
		// FF  01 ̌ɍĐ~(0E 36)

		// ̑OɁAȉӏ̏
		if(version < 3){
		// Kanon
			if(    strcmp(patch->voicefilename,"2\\0753")==0
				|| strcmp(patch->voicefilename,"1\\09a5")==0 ){
				*dest++=*data++; // 0x37(ϐ)
				*dest++=*data++; // 0x20/2C(DATA len 2)
				*dest++=*data++; // 0x69/7B(DATA 1)
				*dest++=*data++; // 0x11(DATA 2)
				*dest++=*data++; // 0x19(wait)
			}
			if(strcmp(patch->voicefilename,"3\\03c4")==0){
				*dest++=*data++; // 0x19(wait)
			}
			if(strcmp(patch->voicefilename,"1\\0228")==0){
				*dest++=*data++; // 0x02
			}
			
		// AIR
		} else if(version == 3){
			if(strcmp(patch->voicefilename,"11\\0044")==0){
				*dest++=*data++; *dest++=*data++; // 0x17 - 0x01(ʂh炷)
				*dest++=*data++; // 0x11(t@CLbVɓǂݍ)
			}
			if(strcmp(patch->voicefilename,"18\\0078")==0){
				*dest++=*data++; *dest++=*data++; // 0x17 - 0x01(ʂh炷)
				*dest++=*data++; // 0x11(t@CLbVɓǂݍ)
				*dest++=*data++; *dest++=*data++; // 0x17 - 0x01(ʂh炷)
				*dest++=*data++; // 0x11(t@CLbVɓǂݍ)
				*dest++=*data++; *dest++=*data++; // 0x17 - 0x01(ʂh炷)
				*dest++=*data++; // 0x11(t@CLbVɓǂݍ)
			}
			if(strcmp(patch->voicefilename,"18\\0103")==0){
				*dest++=*data++; *dest++=*data++; // 0x17 - 0x01(ʂh炷)
				*dest++=*data++; // 0x13(LbVNA)
			}
			if(strcmp(patch->voicefilename,"12\\01dd")==0){
				*dest++=*data++; *dest++=*data++; // 0x17 - 0x01(ʂh炷)
				*dest++=*data++; // 0x11(t@CLbVɓǂݍ)
			}
			if(strcmp(patch->voicefilename,"18\\024b")==0){
				*dest++=*data++; *dest++=*data++; // 0x17 - 0x01(ʂh炷)
				*dest++=*data++; // 0x11(t@CLbVɓǂݍ)
			}
			if(strcmp(patch->voicefilename,"11\\051e")==0){
				*dest++=*data++; *dest++=*data++; // 0x17 - 0x01(ʂh炷)
				*dest++=*data++; *dest++=*data++; // 0x17 - 0x01(ʂh炷)
			}
			if(strcmp(patch->voicefilename,"21\\0283")==0){
				*dest++=*data++; *dest++=*data++; // 0x17 - 0x01(ʂh炷)
				*dest++=*data++; // 0x10(摜obt@Ƀt@Cǂݍ)
				*dest++=*data++; *dest++=*data++; // 0x17 - 0x01(ʂh炷)
				*dest++=*data++; // 0x10(摜obt@Ƀt@Cǂݍ)
			}
			if(strcmp(patch->voicefilename,"21\\0284")==0){
				*dest++=*data++; *dest++=*data++; // 0x17 - 0x01(ʂh炷)
				*dest++=*data++; // 0x10(摜obt@Ƀt@Cǂݍ)
				*dest++=*data++; *dest++=*data++; // 0x17 - 0x01(ʂh炷)
				*dest++=*data++; // 0x10(摜obt@Ƀt@Cǂݍ)
				*dest++=*data++; *dest++=*data++; // 0x17 - 0x01(ʂh炷)
				*dest++=*data++; // 0x10(摜obt@Ƀt@Cǂݍ)
				*dest++=*data++; *dest++=*data++; // 0x17 - 0x01(ʂh炷)
				*dest++=*data++; // 0x10(摜obt@Ƀt@Cǂݍ)
			}
			if(strcmp(patch->voicefilename,"22\\01d4")==0){
				*dest++=*data++; *dest++=*data++;// 0x17 - 0x01(ʂh炷)
				*dest++=*data++; // 0x11(t@CLbVɓǂݍ)
			}
			if(strcmp(patch->voicefilename,"01\\0ed9")==0){
				for(int i=0; i<14; i++){ // 0x19(wait) - 0x01 n܂Ȁ܂Ƃ߂ăXLbvi
				*dest++=*data++;
				}
			}
			if(strcmp(patch->voicefilename,"17\\0603")==0){
				for(int i=0; i<21; i++){ // 0x19(wait) - 0x01 n܂Ȁ܂Ƃ߂ăXLbvi
				*dest++=*data++;
				}
			}
			if(strcmp(patch->voicefilename,"02\\08ac")==0){
				*dest++=*data++; *dest++=*data++; // 0x0e - 0x10 (fade out)
				Data();
				*dest++=*data++; *dest++=*data++; // 0x19(wait) - 0x01
				Data();
				*dest++=*data++; // 0x04
			}
			if(strcmp(patch->voicefilename,"13\\0074")==0){
				*dest++=*data++; *dest++=*data++; // 0x17 - 0x01(ʂh炷)
				*dest++=*data++; // 0x11(摜obt@Ƀt@Cǂݍ)
				*dest++=*data++; *dest++=*data++; // 0x17 - 0x01(ʂh炷)
				*dest++=*data++; // 0x11(摜obt@Ƀt@Cǂݍ)
			}

			// 0x02 - 0x01isj2̑䎌AĂꍇ̏
			if(
					(strcmp(patch->voicefilename,"00\\0097")==0 && (patch->address==123412 || patch->address==123418))
				||(strcmp(patch->voicefilename,"01\\08b3")==0 && patch->address==15490)
				||(strcmp(patch->voicefilename,"02\\007e")==0 && patch->address==202318)
				||(strcmp(patch->voicefilename,"02\\06d8")==0 && patch->address==120547)
				||(strcmp(patch->voicefilename,"11\\0089")==0 && patch->address==67715)
				||(strcmp(patch->voicefilename,"17\\04e5")==0 && patch->address==14679)
				||(strcmp(patch->voicefilename,"17\\0184")==0 && patch->address==36153)
				||(strcmp(patch->voicefilename,"18\\0192")==0 && patch->address==3988)
				||(strcmp(patch->voicefilename,"18\\0411")==0 && patch->address==22233)
				||(strcmp(patch->voicefilename,"18\\0514")==0 && patch->address==12323)
				||(strcmp(patch->voicefilename,"18\\0515")==0 && patch->address==12399)
				||(strcmp(patch->voicefilename,"18\\0516")==0 && patch->address==12477)
				||(strcmp(patch->voicefilename,"18\\0517")==0 && patch->address==12583)
				||(strcmp(patch->voicefilename,"18\\0518")==0 && patch->address==12661)
				||(strcmp(patch->voicefilename,"18\\0519")==0 && patch->address==12767)
				||(strcmp(patch->voicefilename,"18\\051a")==0 && patch->address==12837)
				){
				*dest++=*data++; *dest++=*data++; // 0x02 - 0x01
				*dest++=*data++; // 0xFF
				Int();
				String();
			}

		}

		//  01
		if(*data==0x01){
			*dest++=*data++; // 0x01(wait)
		}else if(strcmp(patch->voicefilename,"11\\051e")==0){
			;
		}else{
			printf("̃G[P %s %d data=0x%x\n",patch->voicefilename,patch->address,*data);
		}
		
		// Đ~
		*dest++=0x0e;
		*dest++=0x36;
	}

	return;
}

void Csenariopatch::Wait() {
	int subcmd = *dest++ = *data++;
		if (subcmd < 0x10) {
			// wait operation
			switch(subcmd) {
				case 0x01: Data(); break;
				case 0x02: case 0x05: Data(); Data(); break;
				case 0x03: break;
				case 0x04: Data(); break;
				case 0x06: Data(); break;
				default: break;
			}
		} else if (subcmd < 0x20) {
	}
	return;
}

void Csenariopatch::Music(){
	int subcmd;
	subcmd = *dest++=*data++;
	switch(subcmd) {
		case 0x01: String(); break;
		case 0x02: break;
		case 0x03: String(); break;
		case 0x05: case 0x06: case 0x07: String(); Data(); break;
		case 0x10: Data(); break;
		case 0x12: case 0x11: break;
		case 0x15: Data(); break;
		case 0x16: break;
#if 1 /* @@@ */
		case 0x20:
		case 0x21: /* if (version==0) String(); else */ Data(); break;
		case 0x22: /* if (version==0) String(); else */ Data(); Data(); break;
#endif
		case 0x23: break;
		case 0x30: String(); break;
#if 1 /* @@@ */
		case 0x31: case 0x33: case 0x35: String(); Data(); break;
#endif
		case 0x32: case 0x34: String(); break;
		case 0x36: break;
		case 0x37: Data(); break;
		case 0x38: case 0x3a: break;
		case 0x39: Data(); break;
		case 0x44: Data(); break;
		case 0x54:
		case 0x55: String();
		case 0x50: case 0x51: case 0x52: case 0x53:
		case 0x70: case 0x71: case 0x72: case 0x73:
			String();
			Data(); Data();
			Data(); Data();
			break;
		case 0x60: case 0x61: case 0x62: case 0x78:
			break;
		default: 
			return;
	}
	return;
}

void Csenariopatch::VargroupRead() {
	*dest++=*data++;
	Data();
	while(*data != 0) {
		Data();
	}
	*dest++=*data++;
}
void Csenariopatch::VargroupSet() {
	*dest++=*data++;
	Data();
	Data();
	Data();
}
void Csenariopatch::VargroupCopy() {
	*dest++=*data++;
	Data();
	Data();
	Data();
}

void Csenariopatch::senariotrace(unsigned char *ptr,unsigned char *ptr2,int rest){
// xkanonsenario.cc
// int SENARIO_DECODE::DecodeSkip pNB

	unsigned char cmd,subcmd;
	int n,i,temp,offset;
	int* tempptr;
	unsigned int tmp;
	int padlen2, str, j, k, l, m;
	int dummy;
	unsigned char num;
	unsigned char subnum[8];
	unsigned char subcountmax[8][8];

	data=ptr;
	datatop=ptr;
	dataend=data+rest;
	dest=ptr2;

/*
	//悭킩Ȃǂł͂߂ɂ̃f[^΂炵
	padlen=(int)(data[0x18]);
	padlen*=4;
	padlen+=0x63;
*/

/* wb_΂[` from ӂforMac */
	padlen=getint(data+0x18);
	padlen*=4;
	padlen+=0x50;
	padlen2 = ((getint(data+padlen)==5)?4:0); //uPvp̕ύX炵c
	num = getint(data+padlen-0x24);
	str = 0;
	for (m=0; m<num; m++){
		subnum[m] = data[padlen+1];
		padlen += 2;
		str++;
		for (j=0; j<subnum[m]; j++){
			subcountmax[m][j] = data[padlen]+1;
			padlen += 2;
			str++;
			for (k=0; k<subcountmax[m][j]; k++){
				dummy = data[padlen];
				padlen++;
				for (l=0; l<dummy; l++){
					padlen += 3;
				}
			}
		}
	}
	for (m=0; m<str; m++){
		padlen += data[padlen] + 1;
	}
	padlen += (padlen2+0x13);
#ifdef DEBUG
printf("padlen = %d\n",padlen);
#endif
/* ܂ */

	memcpy(dest,data,padlen);
	data+=padlen;
	dest+=padlen;
	currentpadlen=padlen;


	while(data<dataend){
		int pos=data-ptr;
		

		cmd=*dest++=*data++;
		if (cmd >= 0x37 && cmd <= 0x59) {
			// ϐ̑
			if (cmd == 0x59) CalcStr();
			else if (cmd == 0x58) Select();
			else CalcVar(cmd);
		}else{

		switch(cmd){
		case 0x00:
			// Data EndEEEƂ킯łȂ͗l
			break;
			
		case 0x01:
		case 0x02:
		case 0x03:
		case 0x04:
		case 0x05:
		case 0x10:
			// eLXg
			TextWindow(cmd);
			break;

		case 0xff:
			// eLXg
#ifdef DEBUG
printf("called 0xff\n");
#endif
			TextWindowEx();
			break;
			
#if 1 /* @@@ */
#if 0
		case 0x05:
			*dest++=*data++;
			break;
#endif
		

		case 0x75:
			*dest++=*data++;
			Data();
			break;
#endif
		case 0x08:
			subcmd = *dest++=*data++;
			if (subcmd == 0x10 || subcmd == 0x11) Data();
			break;

		case 0x0b:
			// OtBbN
			GraphicLoadCmd();
			break;

		case 0x0c:
			subcmd = *dest++=*data++;
			switch(subcmd) {
			case 0x10: String(); Data(); break;
			case 0x16: String(); Data(); Data(); Data(); break;
			case 0x13: String(); Data(); Data(); break;
			case 0x19: String(); Data(); Data(); Data(); Data(); break;
			case 0x11: case 0x12: case 0x17: case 0x18: case 0x1a: case 0x30: case 0x20: case 0x24:
				String();
				while(*data != 0) Data();
				*dest++=*data++;
				break;
			case 0x21: case 0x25: break;
			default: break;
			}
			break;

		case 0x0e:
			Music();
			break;

		case 0x13: // fade in / out
			subcmd = *dest++=*data++;
			if (subcmd == 1 || subcmd == 0x10) Data();
			else if (subcmd == 2) { Data(); Data(); }
			else if (subcmd == 3) { Data(); Data(); Data(); }
			else if (subcmd == 4) { Data(); Data(); Data(); Data(); }
			else if (subcmd == 0x11) { Data(); Data(); Data(); }
			break;

		case 0x17: // shake
			*dest++=*data++;
			Data();
			break;
		case 0x18: // ???
			*dest++=*data++;
			Data();
			break;
		case 0x19:
			// wait?
			Wait();
			break;

		case 0x15: // Wv
			Condition();

			//ѐintl
			tempptr=(int*)data;
			temp=*tempptr;
			tmp = swap_endian32((unsigned int)temp);
			offset=calcoffset(currentpatch,tmp); // temp̒
			tmp+=offset;
			
/*#ifdef DEBUG
addjump(&currentjump,*tempptr,temp,pos);
if (*tempptr!=temp) fprintf(stdout,"\njump0x15 %x->%x",*tempptr,temp);
#endif
*/

//printf("%d\n",tmp);
			temp = swap_endian32(tmp);
			tempptr=(int*)dest;
			*tempptr=temp;

			data+=4;
			dest+=4;

			break;


		case 0x16:
			//global jump/call
			*dest++=*data++;
			Data();
			break;

		case 0x1c: // Wv
			//ѐintl
			tempptr=(int*)data;
temp=*tempptr;
tmp = swap_endian32((unsigned int)temp);
			offset=calcoffset(currentpatch,tmp); // temp̒
			tmp+=offset;
			
#ifdef DEBUG
addjump(&currentjump,*tempptr,temp,pos);
if (*tempptr!=temp) fprintf(stdout,"\njump0x1c %x->%x",*tempptr,temp);
#endif

tempptr=(int*)dest;
temp = swap_endian32(tmp);
			*tempptr=temp;
			data+=4;
			dest+=4;
			break;

		case 0x1d: case 0x1e: //on XX goto/gosub
			n = *dest++=*data++; Data();
			i; for (i=0; i<n; i++) {
				//ѐintl
				tempptr=(int*)data;
	temp=*tempptr;
	tmp = swap_endian32((unsigned int)temp);
				offset=calcoffset(currentpatch,tmp); // temp̒
				tmp+=offset;
				
#ifdef DEBUG
addjump(&currentjump,*tempptr,temp,pos);
if (*tempptr!=temp) fprintf(stdout,"\njump0x%x %x->%x",cmd,*tempptr,temp);
#endif

tempptr=(int*)dest;
temp = swap_endian32(tmp);
				*tempptr=temp;
				data+=4;
				dest+=4;
			}
			break;

		case 0x1b: // gosub
			//ѐintl
			tempptr=(int*)data;
temp=*tempptr;
tmp = swap_endian32((unsigned int)temp);
			offset=calcoffset(currentpatch,tmp); // temp̒
			tmp+=offset;
			
#ifdef DEBUG
addjump(&currentjump,*tempptr,temp,pos);
if (*tempptr!=temp) fprintf(stdout,"\njump0x1b %x->%x",*tempptr,temp);
#endif
tempptr=(int*)dest;
temp = swap_endian32(tmp);
			*tempptr=temp;
			data+=4;
			dest+=4;
			break;
		case 0x20: // return/stack init
			*dest++=*data++;
			break;

		case 0x22:
		case 0x23:
		case 0x24:
		case 0x25:
		case 0x26:
		case 0x27:
		case 0x28:
		case 0x29:
			break;
		case 0x2d:
			Int(); break;

		case 0x2e:{
			int arg = *dest++=*data++;
			if (arg == 1) {
				Data();
			} else {
				Data(); Data();
			}
			break;}

		case 0x60:
			subcmd=*dest++=*data++;
			if (subcmd == 4) {
				StringWithFormat();
			} else if (subcmd == 2 || subcmd == 3 || subcmd == 0x10 || subcmd == 0x11 || subcmd == 0x14 || subcmd == 0x31) Data();
			else if (subcmd == 0x15) { Data(); Data(); }
			else if (subcmd == 5 || subcmd == 0x20) ;
			break;

		case 0x63: case 0x64: case 0x67: case 0x68:
			Graphics(cmd);
			break;

		case 0x76:
			if (*data == 1) {
				*dest++=*data++;
				Data();
			} else {
				*dest++=*data++;
			}
			break;

		case 0xfe:
			String();
			break;

		case 0x3b:
			// ϐ
			Data();
			Data();
			break;

		case 0x5b: // ̕ϐCɃZbg
			VargroupRead();
			break;
		case 0x5c: // Zbg
			VargroupSet();
			break;
		case 0x5d: // Rs[
			VargroupCopy();
			break;

		case 0x5f: // ϐH
			subcmd = *dest++=*data++;
			if (subcmd == 0x20) {
				subcmd = *dest++=*data++; Data(); Data();
				for (int i=0; i<subcmd; i++) Data();
				break;
			} else if (subcmd == 0x10) {
				Data(); Data(); Data(); break;
			} else if (subcmd == 1) {
				Data(); subcmd = *dest++=*data++;
				while(subcmd != 0) {
					Data();
					if (subcmd == 2 || subcmd == 0x12) Data();
					subcmd = *dest++=*data++;
				}
				break;
			}
			break;

		case 0x61:
			if (*data == 1) {
				*dest++=*data++;
				Data();Data();Data();Data();Data();
				Data();Data();Data();Data();Data();
			} else if (*data == 2 || *data == 3) {
				*dest++=*data++;
				Data();
			} else if (*data == 4) {
				*dest++=*data++;
			} else if (*data == 0x10 || *data == 0x11 || *data == 0x12) {
				*dest++=*data++;
				Data(); Data();
			} else if (*data == 0x20) {
				*dest++=*data++;
				Data();
			} else if (*data == 0x21) {
				*dest++=*data++;
				Data();
				String();
				Data(); Data(); Data();
				Data(); Data(); Data();
				Data(); Data(); Data();
				break;
			} else if (*data == 0x24) {
				*dest++=*data++;
				subcmd = *dest++=*data++;
				for (int i=0; i<subcmd; i++){
					Data();
					StringWithFormat();
				}
				break;
			} else if (*data == 0x30) {
				*dest++=*data++;
				break;
			} else if (*data == 0x31) {
				*dest++=*data++;
				break;
			}
			break;

		case 0x69:
			{ *dest++=*data++; *dest++=*data++;
				for (i=0; i<6; i++) {
					Data();
				}
			}
			break;

		case 0x6a:
			if (*data == 0x10 || *data == 0x30) {
				int cmd = *data;
				*dest++=*data++;
				*dest++=*data++;
				int arg = *dest++=*data++;
				Data(); Data(); Data();
				if (cmd == 0x30) Data();
				for (i=0; i<arg; i++) {
					String();
					Data();
				}
				Data(); Data(); Data();
				break;
			} else if (*data == 0x03) {
				*dest++=*data++;
				int arg = *dest++=*data++;
				Data(); Data();
				for (i=0; i<arg; i++) {
					String();
					Data();
				}
				*dest++=*data++;
			}
			
			break;

		case 0x6c: {
			int arg = *data;
			if (arg == 2) {
				*dest++=*data++;
				String();
				String();
			} else if (arg == 3) {
				*dest++=*data++;
			} else if (arg == 4) {
				*dest++=*data++; Data(); Data();
			} else if (arg == 5) {
				*dest++=*data++; Data(); Data();
			} else if (arg == 0x10) {
				*dest++=*data++; Data();
			} else if (arg == 0x11) {
				*dest++=*data++; Data();
			} else if (arg == 0x15) {
				*dest++=*data++;
				Data(); Data();
				Data(); Data();
				Condition();
				Int();
			} else if (arg == 0x20) {
				*dest++=*data++; Data(); Data();
			}
			break;
			}

		case 0x6d:
			switch(*data) {
			case 1:
				*dest++=*data++;
				Data();Data(); Data();
				break;
			case 2:
				*dest++=*data++;
				Data(); Data(); Data();
				break;
			case 3:
				*dest++=*data++;
				break;
			case 0x20:
				*dest++=*data++;
				break;
			case 0x21:
				*dest++=*data++;
				break;
			default: break;
			}
			break;

		case 0x6e:
			if (*data == 1 || *data == 2 ||
			 *data == 3 || *data == 4) {
				*dest++=*data++;
				Data();
				break;
			} else if (*data == 5) {
				*dest++=*data++;
				Data(); Data(); Data();
			}
			break;

		case 0x70:
			switch(*dest++=*data++) {
				case 1: case 2: Data(); Data(); Data(); Data(); break;
				case 3: case 4: case 5: case 6: case 0x10: case 0x11: Data(); break;
			}
			break;
		case 0x72:
			 *dest++=*data++; Data(); Data();
			break;

		case 0x73:
			*dest++=*data++; Data();
			break;

		case 0x74:
			switch(*dest++=*data++) {
			case 2:
				Data(); break;
			case 4:
				Data(); Data(); break;
			default: break;
			}
			break;

		case 0x7f: Data(); break;

		case 0x31:
			if (*data == 2) {
				*dest++=*data++;
				break;
			}
			break;
			
		default:
#ifdef DEBUG
			printf("̃G[Q cmd=0x%02x\n",cmd);
#else
			;
#endif
		} // end switch
		} // end if
	}
}
